!= Program Arare
!
! Authors::   SUGIYAMA Ko-ichiro, ODAKA Masatsugu
! Version::   $Id: arare_3d.f90,v 1.4 2007/10/01 08:50:10 odakker Exp $
! Tag Name::  $Name: arare4-20071012 $
! Copyright:: Copyright (C) GFD Dennou Club, 2007. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
! ϳإǥ deepconv/arare. 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!  * ϤϽవ̷.
!  * ȤΥƥȷ׻.
!
!== Future Plans
!
!

program arare
  !
  !ϳإǥ deepconv/arare. 
  !

  !----- ⥸塼ɤ߹ ------

  !-----   , ʸ   ----
  use dc_types,       only : STRING, DP

  !-----   å   ------
  use dc_message,     only: MessageNotify

  !-----    ⥸塼   -----
  !  ̷׻⥸塼
  !  ̷׻⥸塼
  use ChemCalc, only: ChemCalc_init
  use chemdata, only: chemdata_init

  !  ϥե̾⥸塼
  use fileset_3d,       only : fileset_init, &
    &                       InitFile

  !  ޥɥ饤
  use argset,        only : argset_init

  !  ִ⥸塼
  use timeset,       only : timeset_init, &
    &                       NstepLong, NstepShort, DelTimeLong, DelTimeShort, &
    &                       NstepDisp

  !  ʻ⥸塼 
  use gridset_3d,    only : gridset_init, &
    &                       DimXMin, DimXMax, &
    &                       DimYMin, DimYMax, &
    &                       DimZMin, DimZMax, &
    &                       SpcNum

  !  ܾ⥸塼
  use basicset_3d,   only : basicset_init, &
    &                       xyz_DensBasicZ, xyz_PotTempBasicZ, &
    &                       xyz_VelSoundBasicZ

  !  ѻʹ⥸塼
  use StorePotTemp_3d,    only : StorePotTemp_init, StorePotTempClean, &
    &                           StorePotTempCond

  !  롼⥸塼
  use moistset,      only: moistset_init


  !-----    ⥸塼   -----
  !  ໤׻⥸塼 
  use damping_3d,    only : damping_init, & 
    &                       xyz_DampSponge, pyz_DampSponge, xyr_DampSponge, &
    &                       xqz_DampSponge

  !  ʬե륿⥸塼
  use timefilter_3d,    only : AsselinFilter

  !  Ŭѥ⥸塼
  use xyz_bc_module, only : BoundaryXCyc_xyz, BoundaryYCyc_xyz, &
    &                       BoundaryZSym_xyz, BoundaryZCyc_xyz, &
    &                       BoundaryXCyc_pyz, BoundaryYCyc_pyz, &
    &                       BoundaryZSym_pyz, BoundaryZCyc_pyz, &
    &                       BoundaryXCyc_xqz, BoundaryYCyc_xqz, &
    &                       BoundaryZSym_xqz, BoundaryZCyc_xqz, &
    &                       BoundaryXCyc_xyr, BoundaryYCyc_xyr, &
    &                       BoundaryZSym_xyr, BoundaryZCyc_xyr, &
    &                       BoundaryZAsym_xyr

  !  CFL ǧ⥸塼
  use cflcheck_3d,      only : CFLCheckTimeShort, &
    &                       CFLCheckTimeLongVelX, &
    &                       CFLCheckTimeLongVelY, &
    &                       CFLCheckTimeLongVelZ

  !  μ̤Ŷ׻⥸塼
  !use fillnegative,  only : FillNegative_init, xza_FillNegative_xza


  !-----    ϥ⥸塼   -----
  !  ꥹȥեϥ⥸塼
  use RestartFileIO_3d, only : ReStartFile_Open, ReStartFile_OutPut, &
    &                       ReStartFile_Close, ReStartFile_Get

  !  ҥȥեϥ⥸塼
  use HistoryFileIO_3d, only : HistoryFile_Open, HistoryFile_OutPut, &
    &                       HistoryFile_Close

  !-----       ϳز        -----
  !  ϳز׻Ѵؿ⥸塼
  use DynFunc_3d,       only : xyz_AdvScalar, xyz_AdvKm, &
    &                       pyz_AdvVelX, xqz_AdvVelY,      &
    &                       xyr_Buoy, xyr_AdvVelZ, pyz_GradPi, xqz_GradPi
  
  !  ϳزˡ׻Ѵؿ⥸塼
  use DynImpFunc_3d,    only : xyz_Exner_init, xyz_Exner, xyr_GradPi
  
  !-----       ʪ        -----
  !  ͳȻ׻ѥ⥸塼
  use NumDiffusion_3d,  only : NumDiffusion_Init, xyz_NumDiffScalar, &
    &                       pyz_NumDiffVelX, xqz_NumDiffVelY, xyr_NumDiffVelZ 

  !  ήȻ׻ѥ⥸塼
  use Turbulence_3d,   only : Turbulence_Init, &
    &                      xyz_TurbScalar, xyza_TurbScalar, pyz_TurbVelX, &
    &                      xyr_TurbVelZ  , xyz_ShearKm    , xyz_DispKm,   &
    &                      xyz_DispHeat  , xqz_TurbVelY   , EddyViscosity

  !  Ͷ׻ѥ⥸塼
  use Radiation_3d,    only : Radiation_init,  &
    &                      xyz_RadHeatConst, xyz_NewtonCool
  
  !  ɽեå׻ѥ⥸塼
  use HeatFlux_3d,     only : xyz_HeatFluxBulk, &
    &                         pyz_MomFluxBulk, xqz_MomFluxBulk

  !  ˰Ĵˡ׻ѥ⥸塼
  !use MoistAdjust,  only : MoistAdjustSvapPress, MoistAdjustNH4SH

  !  ʪѥ᥿ꥼ
  !use WarmRainPrm,  only : WarmRainPrm_Init, xz_Rain2GasHeat, xza_Rain2Gas, &
  !  &                      xza_Rain2GasNH4SH, xz_Rain2GasHeatNH4SH,         &
  !  &                      xza_Cloud2Rain, xza_FallRain

  !  ᵤϷ׻ѥ⥸塼
  !use MoistBuoyancy,only : MoistBuoy_Init, xz_BuoyMoistKm, xr_BuoyMolWt, &
  !  &                      xr_BuoyDrag

  !  Ǯ徺βٸΨ׻ѥ⥸塼
!  use ECCM_3D,       only : eccm_init 


  !ۤηػ
  implicit none

  !ѿ
  character(80) :: cfgfile
  Real(DP), allocatable :: pyz_VelXBl(:,:,:)
  real(DP), allocatable :: pyz_VelXNl(:,:,:)
  real(DP), allocatable :: pyz_VelXAl(:,:,:)
  real(DP), allocatable :: pyz_VelXNs(:,:,:)
  real(DP), allocatable :: pyz_VelXAs(:,:,:)
  Real(DP), allocatable :: xqz_VelYBl(:,:,:)
  real(DP), allocatable :: xqz_VelYNl(:,:,:)
  real(DP), allocatable :: xqz_VelYAl(:,:,:)
  real(DP), allocatable :: xqz_VelYNs(:,:,:)
  real(DP), allocatable :: xqz_VelYAs(:,:,:)
  real(DP), allocatable :: xyr_VelZBl(:,:,:)
  real(DP), allocatable :: xyr_VelZNl(:,:,:)
  real(DP), allocatable :: xyr_VelZAl(:,:,:)
  real(DP), allocatable :: xyr_VelZNs(:,:,:)
  real(DP), allocatable :: xyr_VelZAs(:,:,:)
  real(DP), allocatable :: xyz_ExnerBl(:,:,:)
  real(DP), allocatable :: xyz_ExnerNl(:,:,:)
  real(DP), allocatable :: xyz_ExnerAl(:,:,:)
  real(DP), allocatable :: xyz_ExnerNs(:,:,:)
  real(DP), allocatable :: xyz_ExnerAs(:,:,:)
  real(DP), allocatable :: xyz_PotTempWork(:,:,:)
  real(DP), allocatable :: xyz_PotTempBl(:,:,:)
  real(DP), allocatable :: xyz_PotTempNl(:,:,:)
  real(DP), allocatable :: xyz_PotTempAl(:,:,:)
  real(DP), allocatable :: xyz_KmBl(:,:,:)
  real(DP), allocatable :: xyz_KmNl(:,:,:)
  real(DP), allocatable :: xyz_KmAl(:,:,:)
  real(DP), allocatable :: xyz_KhBl(:,:,:)
  real(DP), allocatable :: xyz_KhNl(:,:,:)
  real(DP), allocatable :: xyz_KhAl(:,:,:)

  real(DP), allocatable :: pyz_AccelVelXNl(:,:,:)
  real(DP), allocatable :: xqz_AccelVelYNl(:,:,:)
  real(DP), allocatable :: xyr_AccelVelZNl(:,:,:)

  real(DP)              :: Time
  real(DP)              :: ReStartTime(2)
  real(DP), allocatable :: DelTimeLFrog(:)
  real(DP)              :: DelTimeEuler
  integer, allocatable  :: NStepEuler(:)
  integer               :: NStepLFrog

  integer               :: t, tau, t1, t2   


  !----------------------------------------------------------------------
  ! ѿȷ⥸塼ν
  !----------------------------------------------------------------------

  !ޥɥ饤β
  !  NAMELIST ե̾ɤ߹
  call argset_init(cfgfile)

  !ʪν
  call chemdata_init()

  !˴ؤν
  !  NAMELIST ɬפʾɤ߼, ִϢѿԤ. 
  call timeset_init(cfgfile)

  !ʻν
  !  NAMELIST , ʻ׻
  call gridset_init(cfgfile)

  !ط׻롼ν
  call chemcalc_init()
  
  !ܾξν
  !  NAMELIST , ܾꤹ.
  call basicset_init(cfgfile)
  
  !I/O ե̾ν
  !  NAMELIST ե̾ꤷ, deepconv/arare 
  !  ϥե̾ NAMELIST 
  call fileset_init(cfgfile)

  !롼ζͭѿν
  call moistset_init()
 
  !ѻͤݴɤ뤿Υ⥸塼ν
  !  NAMELIST , ܾꤹ.
  call StorePotTemp_init( )
  
  !ѿν. ȤꤢͤꤵƤ. 
  call VariableAllocate
  
  !ͽѿν
  !  ReStartFile ꤵƤˤϥեɤ߹, 
  !  ꤵƤʤˤ, ǥեȤδܾȾ. 
  if (trim(InitFile) /= '') then    

    !ܾ, νͤ netCDF ե뤫.
    call ReStartFile_Get(            &
      & ReStartTime,                 &
      & xyz_PotTempBl, xyz_ExnerBl, pyz_VelXBl, xqz_VelYBl, xyr_VelZBl, &
      & xyz_KmBl,      xyz_KhBl,              &
      & xyz_PotTempNl, xyz_ExnerNl, pyz_VelXNl, xqz_VelYBl, xyr_VelZNl, &
      & xyz_KmNl,    xyz_KhNl                         )
  else
    !ǥեδܾ, . 
    call BasicEnv_3d()
    call DisturbEnv_3d(cfgfile,                             &
      & xyz_PotTempBl, xyz_ExnerBl, pyz_VelXBl, xqz_VelYBl, xyr_VelZBl, &
      & xyz_KmBl,    xyz_KhBl                 )

    call BoundaryXCyc_pyz( pyz_VelXBl )
    call BoundaryYCyc_pyz( pyz_VelXBl )
    call BoundaryZSym_pyz( pyz_VelXBl )

    call BoundaryXCyc_xqz( xqz_VelYBl )
    call BoundaryYCyc_xqz( xqz_VelYBl )
    call BoundaryZSym_xqz( xqz_VelYBl )

    call BoundaryXCyc_xyr( xyr_VelZBl )
    call BoundaryYCyc_xyr( xyr_VelZBl )
    call BoundaryZAsym_xyr( xyr_VelZBl )

    call BoundaryXCyc_xyz( xyz_PotTempBl )
    call BoundaryYCyc_xyz( xyz_PotTempBl )
    call BoundaryZSym_xyz( xyz_PotTempBl )

    
    ! 1 롼ܤ, bl  nl ͤƱˤƤ. 
    ! 1 ƥåܤϥ顼ˡǲɬפ뤬, 
    ! 1 ƥåܤȤʳΥƥåפ̡˥ǥ󥰤ʤ
    xyz_PotTempNl = xyz_PotTempBl
    xyz_ExnerNl   = xyz_ExnerBl
    pyz_VelXNl    = pyz_VelXBl
    xqz_VelYNl    = xqz_VelYBl
    xyr_VelZNl    = xyr_VelZBl
    xyz_KmNl      = xyz_KmBl
    xyz_KhNl      = xyz_KhBl

  end if


  !----------------------------------------------------------------------
  ! ѥå⥸塼ν
  !   ǥեȤͤѹɬפΤ롼Τ߽
  !----------------------------------------------------------------------
  call Damping_Init( cfgfile )      !Ȥθ그ν
  call NumDiffusion_Init()          !ͳȻν
  call Turbulence_Init()            !ή׻ν
!  call MoistAdjust_Init()           !˰Ĵˡν
!  call WarmRainPrm_Init( cfgfile )  !ȤΥѥ᥿ꥼν
!  call FillNegative_Init( xza_MixRtBasicZ, xz_DensBasicZ) 
                                    !ήˤ̤ν
  call Radiation_Init( cfgfile )    !Ͷν
!  call MoistBuoy_Init()             !ʬ̤ФϷ׻롼ν
  call xyz_Exner_Init()             !ˡν  

     

  !----------------------------------------------------------------------
  ! ȥ롼ײν 
  !----------------------------------------------------------------------
  NstepLFrog   = NstepLong 
  NstepEuler   = NstepShort 
  DelTimeLFrog = DelTimeLong * 2.0d0 
  DelTimeEuler = DelTimeShort
  if ( trim(InitFile) /= '') then    
    Time = ReStartTime(2)                 !ꥹȳϻ
  else
    Time = 0.0d0                          ! ׻ϻ
    NstepEuler(1)   = NstepShort /2       ! 1 롼ܤ
    DelTimeLFrog(1) = DelTimeLong         ! 1 롼ܤ
  end if

  call MessageNotify( "M", "main", "NstepLong= %d", i=(/NstepLong/) )
  call MessageNotify( "M", "main", "NstepEuler= %d", i=(/NstepEuler/) )
  call MessageNotify( "M", "main", "DelTimeLFrog= %f", d=(/DelTimeLFrog/) )
  call MessageNotify( "M", "main", "DelTimeEuler= %f", d=(/DelTimeEuler/) )

  !----------------------------------------------------------------
  ! ե
  !----------------------------------------------------------------
  !ե륪ץ

  call HistoryFile_Open( )

  if ( trim(InitFile) /= '') then    
    call HistoryFile_Output(  &
      &  ReStartTime(2),      &
      &  xyz_PotTempNl,        &
      &  xyz_ExnerNl,          &
      &  pyz_VelXNl,           &
      &  xqz_VelYNl,           &
      &  xyr_VelZNl,           &
      &  xyz_KmNl,             &
      &  xyz_KhNl            )
  end if

  ! 0 ξˤϽ
  if ( Time == 0 ) then
    call HistoryFile_Output(  &
      &  Time,                &
      &  xyz_PotTempNl,        &
      &  xyz_ExnerNl,          &
      &  pyz_VelXNl,           &
      &  xqz_VelYNl,           &
      &  xyr_VelZNl,           &
      &  xyz_KmNl,             &
      &  xyz_KhNl            )
  end if
  
  !----------------------------------------------------------------------
  ! Υå
  !----------------------------------------------------------------------
  !CFL Υå
  call CFLCheckTimeShort( xyz_VelSoundBasicZ )

  !----------------------------------------------------------------------
  ! ʬ
  !----------------------------------------------------------------------
  call MessageNotify( "M", "main", "Time Integration Start" )

  do t1 = 1, NstepLFrog / NstepDisp
    do t2 = 1, NstepDisp

      t = (t1 - 1) * NstepDisp + t2


      !
      Time = Time + DelTimeLong
!      call MessageNotify( "M", "main", "Time = %f", d=(/Time/) )

      !----------------------------------------------------------------
      ! Ǵ, Ȼ.
      !----------------------------------------------------------------

      call EddyViscosity(pyz_VelXNl, xqz_VelYNl, xyr_VelZNl, xyz_PotTempNl, &
        &                xyz_KmNl  , xyz_KmAl                  )

      !ͤξ²¤
      !  * ͤˤʤ뤳Ȥݾڤ
      !  * ͤξ¤ 800 Ȥ. (1994, ذʸ)
     xyz_KmAl = max( 0.0d0, min( xyz_KmAl, 800.0d0 ) )
!!     xyz_KmAl = max( 0.0d0, min( xyz_KmAl, 300.0d0 ) )

      !
      call BoundaryXCyc_xyz( xyz_KmAl )
      call BoundaryYCyc_xyz( xyz_KmAl )
      call BoundaryZSym_xyz( xyz_KmAl )
      
      !Ȼ
      xyz_KhAl = 3.0d0 * xyz_KmAl


      !----------------------------------------------------------------
      ! ̤ΰή׻.
      !----------------------------------------------------------------    
      !ʬ

!      call MessageNotify( "M", "main", "Time Integration: Temperature" )

      xyz_PotTempAl =                                              &
        &   xyz_PotTempBl                                          &
        & + DelTimeLFrog(t)                                        &
        &   * (                                                    &
        &     + xyz_AdvScalar( xyz_PotTempNl,                      &
        &                      pyz_VelXNl, xqz_VelYNl, xyr_VelZNl) &
        &     + xyz_AdvScalar( xyz_PotTempBasicZ,                  &
        &                      pyz_VelXNl, xqz_VelYNl, xyr_VelZNl) &
        &     + xyz_NumDiffScalar(xyz_PotTempBl)                   &
        &     + xyz_TurbScalar(xyz_PotTempBl,     xyz_KhBl)        &
        &     + xyz_TurbScalar(xyz_PotTempBasicZ, xyz_KhBl)        &
!!      &     + xyz_DispHeat( xyz_KmBl )                           &
        &     + xyz_RadHeatConst( xyz_ExnerBl )                    &
!!      &     + xyz_HeatFluxDiff( xyz_PotTempNl )                  &
        &     + xyz_HeatFluxBulk( xyz_PotTempBl, pyz_VelXBl, xqz_VelYBl ) &
!!      &     + xyz_NewtonCool( xyz_PotTempBl )                    &
      &      )

      !
      call BoundaryXCyc_xyz( xyz_PotTempAl )
      call BoundaryYCyc_xyz( xyz_PotTempAl )
      call BoundaryZSym_xyz( xyz_PotTempAl )
      
      !-------------------------------------------------------------
      ! Ĺ֥ƥåפǤ, ®٤ΰή, Ȼ, Ǵ, 
      !-------------------------------------------------------------

      pyz_AccelVelXNl =                                      &
        & + pyz_AdvVelX(pyz_VelXNl, xqz_VelYNl, xyr_VelZNl)  &
        & + pyz_NumDiffVelX(pyz_VelXBl)                      &
        & + pyz_TurbVelX(xyz_KmBl,   pyz_VelXBl, xqz_VelYBl, xyr_VelZBl) &
        & + pyz_MomFluxBulk( pyz_VelXBl )

      xqz_AccelVelYNl =                                      &
        & + xqz_AdvVelY(pyz_VelXNl, xqz_VelYNl, xyr_VelZNl)  &
        & + xqz_NumDiffVelY(xqz_VelYBl)                      &
        & + xqz_TurbVelY(xyz_KmBl,   pyz_VelXBl, xqz_VelYBl, xyr_VelZBl) &
        & + xqz_MomFluxBulk( xqz_VelYBl )

      xyr_AccelVelZNl =                                      &
        & + xyr_AdvVelZ(pyz_VelXNl, xqz_VelYNl, xyr_VelZNl)  &
        & + xyr_Buoy(xyz_PotTempNl)                          &   
        & + xyr_NumDiffVelZ(xyr_VelZBl)                      &   
        & + xyr_TurbVelZ(xyz_KmBl,   pyz_VelXBl, xqz_VelYBl, xyr_VelZBl) 



      !-------------------------------------------------------------
      ! û֥ƥåפνͺ
      !-------------------------------------------------------------
      pyz_VelXNs  = pyz_VelXBl
      xqz_VelYNs  = xqz_VelYBl
      xyr_VelZNs  = xyr_VelZBl
      xyz_ExnerNs = xyz_ExnerBl

     
      !-------------------------------------------------------------
      ! û֥ƥåפʬ. 顼ˡ
      !-------------------------------------------------------------
!      call MessageNotify( "M", "main", "Time Integration: Dynamics" )

      Euler: do tau = 1, NstepEuler(t)

         !-------------------------------------------------------------
         ! ® u η׻
         !-------------------------------------------------------------
!         call MessageNotify( "M", "main", "Time Integration: VelX" )

         pyz_VelXAs = &
           & pyz_VelXNs                                          &
           &  + DelTimeEuler                                     &
           &    * (                                              &
           &     - pyz_GradPi(xyz_ExnerNs, pyz_VelXNs, xqz_VelYNs, xyr_VelZNs) &
           &     + pyz_AccelVelXNl                               &
           &     )

         !
         call BoundaryXCyc_pyz( pyz_VelXAs )
         call BoundaryYCyc_pyz( pyz_VelXAs )
         call BoundaryZSym_pyz( pyz_VelXAs )
         
         !-------------------------------------------------------------
         ! ® v η׻
         !-------------------------------------------------------------
!         call MessageNotify( "M", "main", "Time Integration: VelV" )

         xqz_VelYAs = &
           & xqz_VelYNs                                          &
           &  + DelTimeEuler                                     &
           &    * (                                              &
           &    - xqz_GradPi(xyz_ExnerNs, pyz_VelXNs, xqz_VelYNs, xyr_VelZNs)&
           &     + xqz_AccelVelYNl                               &
           &     )

         !
         call BoundaryXCyc_xqz( xqz_VelYAs )
         call BoundaryYCyc_xqz( xqz_VelYAs )
         call BoundaryZSym_xqz( xqz_VelYAs )

         !-------------------------------------------------------------
         ! ʡؿη׻
         !-------------------------------------------------------------
!         call MessageNotify( "M", "main", "Time Integration: Exner" )

         xyz_ExnerAs = xyz_Exner( &
           & xyr_AccelVelZNl,     &
           & pyz_VelXNs, pyz_VelXAs,      &
           & xqz_VelYNs, xqz_VelYAs,      &
           & xyr_VelZNs, xyz_ExnerNs)
         
         !
         call BoundaryXCyc_xyz( xyz_ExnerAs )
         call BoundaryYCyc_xyz( xyz_ExnerAs )
         call BoundaryZSym_xyz( xyz_ExnerAs )

         !-------------------------------------------------------------
         ! ® w η׻
         !-------------------------------------------------------------
!         call MessageNotify( "M", "main", "Time Integration: VelZ" )

         xyr_VelZAs =                                                   &
           & xyr_VelZNs                                                 &
           &  + DelTimeEuler                                            &
           &    * (                                                     &
           &     - xyr_GradPi(xyz_ExnerAs,xyz_ExnerNs,                  &
           &                  pyz_VelXNs,xqz_VelYNs, xyr_VelZNs)        &
           &     + xyr_AccelVelZNl                                      &
           &     )

         !
         call BoundaryXCyc_xyr( xyr_VelZAs )
         call BoundaryYCyc_xyr( xyr_VelZAs )
         call BoundaryZAsym_xyr( xyr_VelZAs )
         
         !-------------------------------------------------------------
         ! û֥ƥåפΥ롼פ󤹤ν
         !-------------------------------------------------------------
         xyz_ExnerNs  = xyz_ExnerAs
         pyz_VelXNs   = pyz_VelXAs
         xqz_VelYNs   = xqz_VelYAs
         xyr_VelZNs   = xyr_VelZAs
         
      end do Euler
   
      !----------------------------------------------------------------
      ! ǽŪû֥ƥåפǤͤĹ֥ƥåפǤͤȤߤʤ
      !----------------------------------------------------------------
      xyz_ExnerAl  = xyz_ExnerAs
      pyz_VelXAl   = pyz_VelXAs
      xqz_VelYAl   = xqz_VelYAs
      xyr_VelZAl   = xyr_VelZAs
      
      !-------------------------------------------------------------
      ! åλ֥ե륿.  Nl ͤե륿
      !-------------------------------------------------------------
      call AsselinFilter(xyz_ExnerAl, xyz_ExnerNl, xyz_ExnerBl)
      call AsselinFilter(pyz_VelXAl,  pyz_VelXNl,  pyz_VelXBl )
      call AsselinFilter(xqz_VelYAl,  xqz_VelYNl,  xqz_VelYBl )
      call AsselinFilter(xyr_VelZAl,  xyr_VelZNl,  xyr_VelZBl )
      call AsselinFilter(xyz_PotTempAl, xyz_PotTempNl, xyz_PotTempBl)
      call AsselinFilter(xyz_KmAl, xyz_KmNl, xyz_KmBl)

      !-------------------------------------------------------------
      ! ݥ
      !-------------------------------------------------------------
!      pyz_VelXAl = pyz_DampSponge( pyz_VelXAl, pyz_VelXBl, DelTimeLFrog(t) )
!      xqz_VelYAl = xqz_DampSponge( xqz_VelYAl, xqz_VelYBl, DelTimeLFrog(t) )
!      xyr_VelZAl = xyr_DampSponge( xyr_VelZAl, xyr_VelZBl, DelTimeLFrog(t) )


      !----------------------------------------------------------------
      ! Ĺ֥ƥåפΥ롼פ󤹤ν
      !----------------------------------------------------------------
      xyz_PotTempBl = xyz_PotTempNl
      xyz_ExnerBl   = xyz_ExnerNl
      pyz_VelXBl    = pyz_VelXNl
      xqz_VelYBl    = xqz_VelYNl
      xyr_VelZBl    = xyr_VelZNl
      xyz_KmBl      = xyz_KmNl
      xyz_KhBl      = xyz_KhNl
    
      xyz_PotTempNl = xyz_PotTempAl
      xyz_ExnerNl   = xyz_ExnerAl
      pyz_VelXNl    = pyz_VelXAl
      xqz_VelYNl    = xqz_VelYAl
      xyr_VelZNl    = xyr_VelZAl
      xyz_KmNl      = xyz_KmAl
      xyz_KhNl      = xyz_KhAl

    end do
      
    !----------------------------------------------------------------
    ! ե
    !----------------------------------------------------------------

    call MessageNotify( "M", "main", "Time = %f", d=(/Time/) )

    ! CFL Υå
    call CFLCheckTimeLongVelX( pyz_VelXNl )
    call CFLCheckTimeLongVelY( xqz_VelYNl )
    call CFLCheckTimeLongVelZ( xyr_VelZNl )
   
    !ҥȥե
    
    call HistoryFile_Output(  &
      &  Time,                &
      &  xyz_PotTempNl,       &
      &  xyz_ExnerNl,         &
      &  pyz_VelXNl,          &
      &  xqz_VelYNl,          &
      &  xyr_VelZNl,          &
      &  xyz_KmNl,            &
      &  xyz_KhNl             &
      & )

    !ѻͤΥꥢ
    call StorePotTempClean
    
  end do

  !----------------------------------------------------------------
  ! ϥեΥ
  !----------------------------------------------------------------
  call HistoryFile_Close

  call ReStartFile_Open( )
  call ReStartFile_OutPut(                            &
    & Time - DelTimeLong,                             &
    & xyz_PotTempBl, xyz_ExnerBl, pyz_VelXBl, xqz_VelYBl, xyr_VelZBl, &
    & xyz_KmBl , xyz_KhBl &
    & )

  call ReStartFile_OutPut(                            &
    & Time,                                           &
    & xyz_PotTempNl, xyz_ExnerNl, pyz_VelXNl, xqz_VelYNl, xyr_VelZNl, &
    & xyz_KmNl , xyz_KhNl &
    & )

  call ReStartFile_Close
  

contains

  subroutine VariableAllocate
    !
    !Ȥ, , ͤȤƥ.
    !

    !ۤηػ
    implicit none

    !
    allocate(                                                   &
      & pyz_VelXBl(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
      & pyz_VelXNl(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
      & pyz_VelXAl(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
      & pyz_VelXNs(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
      & pyz_VelXAs(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
!
      & xqz_VelYBl(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
      & xqz_VelYNl(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
      & xqz_VelYAl(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
      & xqz_VelYNs(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
      & xqz_VelYAs(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
!
      & xyr_VelZBl(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
      & xyr_VelZNl(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
      & xyr_VelZAl(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
      & xyr_VelZNs(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
      & xyr_VelZAs(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
!
      & xyz_ExnerBl(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
      & xyz_ExnerNl(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
      & xyz_ExnerAl(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
      & xyz_ExnerNs(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
      & xyz_ExnerAs(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
!
      & xyz_PotTempWork(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
      & xyz_PotTempBl(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
      & xyz_PotTempNl(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
      & xyz_PotTempAl(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
!
      & xyz_KmBl(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
      & xyz_KmNl(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
      & xyz_KmAl(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
!
      & xyz_KhBl(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
      & xyz_KhNl(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
      & xyz_KhAl(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
!
      & pyz_AccelVelXNl(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
      & xqz_AccelVelYNl(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),&
      & xyr_AccelVelZNl(DimXMin:DimXMax,DimYMin:DimYMax,DimZMin:DimZMax),& 
      & DelTimeLFrog(NstepLong), NStepEuler(NStepLong)               ) 

    pyz_VelXNs  = 0.0d0;    pyz_VelXAs = 0.0d0    
    xqz_VelYNs  = 0.0d0;    xqz_VelYAs = 0.0d0    
    xyr_VelZNs  = 0.0d0;    xyr_VelZAs = 0.0d0
    xyz_ExnerNs = 0.0d0;    xyz_ExnerAs = 0.0d0

    pyz_VelXBl  = 0.0d0;    pyz_VelXNl  = 0.0d0;    pyz_VelXAl  = 0.0d0
    xqz_VelYBl  = 0.0d0;    xqz_VelYNl  = 0.0d0;    xqz_VelYAl  = 0.0d0
    xyr_VelZBl  = 0.0d0;    xyr_VelZNl  = 0.0d0;    xyr_VelZAl  = 0.0d0
    xyz_ExnerBl = 0.0d0;    xyz_ExnerNl = 0.0d0;    xyz_ExnerAl = 0.0d0
    xyz_KmBl    = 0.0d0;    xyz_KmNl    = 0.0d0;    xyz_KmAl    = 0.0d0
    xyz_KhBl    = 0.0d0;    xyz_KhNl    = 0.0d0;    xyz_KhAl    = 0.0d0
    xyz_PotTempBl = 0.0d0;  xyz_PotTempNl = 0.0d0;  xyz_PotTempAl = 0.0d0

    pyz_AccelVelXNl = 0.0d0
    xqz_AccelVelYNl = 0.0d0
    xyr_AccelVelZNl = 0.0d0

!    xyza_DelMixRt = 0.0d0

    DelTimeEuler = 0.0d0
    DelTimeLFrog = 0.0d0; 
    NStepEuler = 0.0d0
    NstepLFrog = 0.0d0

  end subroutine VariableAllocate
      
end program arare
